/* EasyCODE V8 */
/* EasyCODE ( 0 */
#ifndef _SPI_DRIVER_H
    #define _SPI_DRIVER_H
    /* EasyCODE - */
    #include <system.h>
    /* EasyCODE [ 
    ESPI_CommunicationState */
    /* EasyCODE C */
    typedef enum ESPI_CommunicationState
    {
            eSPI_idle, eSPI_receiving, eSPI_transmitting
    }TSPI_CommunicationState;
    /* EasyCODE E */
    /* EasyCODE ] */
    /* EasyCODE [ 
    ESPI_OperationMode */
    /* EasyCODE C */
    typedef enum ESPI_OperationMode
    {
            eSPI_blockingMaster, eSPI_nonBlockingMaster, eSPI_slave
    }TSPI_OperationMode;
    /* EasyCODE E */
    /* EasyCODE ] */
    /* EasyCODE [ 
    SSPI_State */
    /* EasyCODE C */
    typedef struct SSPI_State
    {
            /* EasyCODE C */
            union USPI_StateFlags
            {
                    u8 asU8;
                    /* EasyCODE C */
                    struct SSPI_StateFlags
                    {
                            u8 initialized		:1;
                            u8 occupied		:1;
                            u8 receivedData	:1;
                            u8 reserve		:5;
                    }asFlags;
                    /* EasyCODE E */
            }state;
            /* EasyCODE E */
            TSPI_CommunicationState communicationState;
            TSPI_OperationMode operationMode;
    }TSPI_State;
    /* EasyCODE E */
    /* EasyCODE ] */
    //frequency is in kHz
    /* EasyCODE - */
    void spi_startUp(void);
    u16 spi_maximumFrequency(void);
    u8 spi_initBlockingMaster(u8 aSPI, u16 freq, TSys_SPIMode mode);
    /* EasyCODE - */
    u8 spi_destruct(u8 aSPI);
    /* EasyCODE - */
    u8 spi_transmitData(u8 aSPI, u8* data, u16 dataLen);
    u8 spi_receiveData(u8 aSPI, u8* data, u16 dataLen);
    /* EasyCODE - */
    u8 spi_changeFrequency(u8 aSPI, u16 freq);
    u8 spi_changeMode(u8 aSPI, TSys_SPIMode mode);
    u8 spi_changeDataOrder(u8 aSPI, u8 lsbFirst);
    u8 spi_changeDataPolarity(u8 aSPI, u8 isInverse);
#endif 
/* EasyCODE ) */
