/* EasyCODE V8 */
/* EasyCODE ( 0 */
#ifndef _SYSTEM_H
    #define _SYSTEM_H
    /* EasyCODE - */
    #include <sys_cpu.h>
    #include <sys_config.h>
    /* EasyCODE - */
    typedef unsigned char u8;
    typedef unsigned int u16;
    typedef unsigned long u32;   
    typedef unsigned int word;
    typedef unsigned char byte;
    /* EasyCODE - */
    #define FALSE 0
    #define TRUE !FALSE
    /* EasyCODE ( 0 
    Types */
    /* EasyCODE ( 0 
    USys_ReceivedData */
    /* EasyCODE C */
    typedef union USys_ReceivedData
    {
            u16 asU16;
            u8 asU8[2];
            /* EasyCODE C */
            struct SSys_ReceivedDataInfo
            {
                    u8 dataByte	: 8;
                    u8 dataBit8				:	 1;
                    u8 reserve				: 1;
                    /* EasyCODE C */
                    union UErrors
                    {
                            u8 asU8 : 6;
                            /* EasyCODE C */
                            struct SSys_ReceivedDataErrorFlags
                            {
                                    u8 arbitrationLost	: 1;
                                    u8 bufferOverrun	: 1;
                                    u8 framing		: 1;
                                    u8 parity			: 1;
                                    u8 collision		: 1;
                                    u8 sum			: 1;
                            }asFlags;
                            /* EasyCODE E */
                    }errors;
                    /* EasyCODE E */
            }info;
            /* EasyCODE E */
    }TSys_ReceivedData;
    /* EasyCODE E */
    /* EasyCODE ) */
    typedef void (*TSys_ReceiveEvent)(u8, TSys_ReceivedData);
    /* EasyCODE ( 0 
    ESys_SPIPrescaler */
    /* EasyCODE C */
    typedef enum ESys_SPIPrescaler
    {
            eSys_SPIPrescaler2=2,
            eSys_SPIPrescaler4=4,
            eSys_SPIPrescaler8=8,
            eSys_SPIPrescaler16=16,
            eSys_SPIPrescaler32=32,
            eSys_SPIPrescaler64=64,
            eSys_SPIPrescaler128=128
    }TSys_SPIPrescaler;
    /* EasyCODE E */
    /* EasyCODE ) */
    /* EasyCODE ( 0 
    ESys_SPIMode */
    /* EasyCODE C */
    typedef enum ESys_SPIMode
    {
            eSys_SPIMode0,
            eSys_SPIMode1,
            eSys_SPIMode2,
            eSys_SPIMode3
    }TSys_SPIMode;
    /* EasyCODE E */
    /* EasyCODE ) */
    /* EasyCODE ) */
    u8 Sys_spiEnable(u8 aSPI);
    u8 Sys_spiDisable(u8 aSPI);
    u8 Sys_spiSetSpeed(u8 aSPI, TSys_SPIPrescaler speed); 
    u8 Sys_spiSetDataOrder(u8 aSPI, u8 lsbFirst);
    u8 Sys_spiSetMode(u8 aSPI, TSys_SPIMode mode);
    u8 Sys_spiSetDataPolarity(u8 aSPI, u8 isInverse);
    u8 Sys_spiTransceiveData(u8 aSPI, u8 data); 
    u8 Sys_spiSetMasterSlave(u8 aSPI, u8 isMaster);
#endif 
/* EasyCODE ) */
