/* EasyCODE V8 */
/* EasyCODE ( 0 
main */
#include <system.h>
#include <flash_memory.h>
#include <boot_loader.h>
#include <spi_driver.h>
#include <string.h>
/* EasyCODE ( 0 
sendTextMessage (DEBUG) */
#ifdef _USE_DEBUG
    /* EasyCODE F */
    static void sendText(u8* text)
    {
        while ( *text != '\0' )
        {
            USARTC0.STATUS &= USART_DREIF_bm; //DRE
            /* EasyCODE - */
            USARTC0.DATA=*text;
            text++;
            while ( !(USARTC0.STATUS & USART_DREIF_bm) )
            {
                ;
            }
        }
    }

    /* EasyCODE F */
    static void sendTextMessage(u8* text)
    {
        while ( *text != '\0' )
        {
            sendText("BootLoader: ");
            /* EasyCODE - */
            sendText(text);
        }
    }

#endif 
/* EasyCODE ) */
/* EasyCODE ( 0 
main */
/* EasyCODE F */
void main(void)
{
    InitCPUClock();
    /* EasyCODE - */
    register u8 enableFWUpdate;
    /* EasyCODE ( 0 
    Init com port (UARTC0) (DEBUG) */
    #ifdef _USE_DEBUG
        PORTC.OUTSET = PIN3_bm;
        PORTC.DIRSET = PIN3_bm;
        /* EasyCODE - */
        //Enable UART: asynchronous, 1 stopbit, 8 databit and parity disabled
        USARTC0.CTRLC= USART_CMODE_ASYNCHRONOUS_gc | USART_CHSIZE_8BIT_gc | USART_PMODE_DISABLED_gc;
        /* EasyCODE - */
        USARTC0.BAUDCTRLA = 25;
        USARTC0.BAUDCTRLB = 0;
        //uartPtr->BAUDCTRLB |= baudSettings[Baud].bScale << 4;
        /* EasyCODE - */
        //Enable receiver and transmitter
        USARTC0.CTRLB = USART_RXEN_bm | USART_TXEN_bm;
    #endif 
    /* EasyCODE ) */
    spi_startUp();
    /* EasyCODE - */
    InitFlashMemory();
    /* EasyCODE [ 
    DEBUG */
    #ifdef _USE_DEBUG
        sendTextMessage("search new FW!\r\n");
    #endif 
    /* EasyCODE ] */
    enableFWUpdate = CheckUpdateAvailable(0);
    if ( enableFWUpdate == TRUE  )
    {
        /* EasyCODE ( 0 
        DEBUG */
        #ifdef _USE_DEBUG
            sendTextMessage("FW available!\r\n");
        #endif 
        /* EasyCODE ) */
        UpdateFirmware(0);
    }
    else
    {
        /* EasyCODE ( 0 
        DEBUG */
        #ifdef _USE_DEBUG
            sendTextMessage("no FW available!\r\n");
        #endif 
        /* EasyCODE ) */
    }
    /* EasyCODE ( 0 
    DEBUG */
    #ifdef _USE_DEBUG
        sendTextMessage("I'm done!\r\n");
    #endif 
    /* EasyCODE ) */
    JumpToApplication();
}

/* EasyCODE ) */
/* EasyCODE ) */
